#!/bin/bash


##Esto es solo teniendo en cuenta la parte de fallback, como es LXDE
##Deben cambiar algunas aplicaciones que en su defecto son de lxde
override_app_for_cinnamon_in_lxde(){
  app="$1"
  override="$2"
  panels=(`find /home/*/.config/ /etc/xdg/ /etc/skel/.config/ -iname "panel" 2>/dev/null`)
  for p in $panels; do
    sed -re "s/$app/$override/g" -i "$p"
  done
}

##copia una configuraciones .* ocultas menos aquella que se excluya
##Por ahora esta forma
copy_config_environment(){
 cinnamon=$1
 path=$2
 patron=$3
 destino=$4
 exlusion=$5
 configuraciones=`(find "$path" -iname '$patron' >/dev/null)`

 if [ "$cinnamon" -eq 0 ];then
    for config in ${configuraciones[@]}; do
       cp -fr $path/$config "$destino" >/dev/null
    done
  else
     for config in ${configuraciones[@]}; do
      if [ "$config" != "$exclusion" ]; then
      cp -fr $path/$config "$destino" >/dev/null
    fi
   done
 fi
}

is_installed(){
	[ -n "$(dpkg -l "$1" | grep -E '^ii')" ]
}

override_cinnamon_desktop(){
# Esto deberíamos manejarlo en el paquete cinnamon o en su defecto
# en el módulo cinnamon. Fernando.
 if [ -e /usr/share/gnome-session/sessions/cinnamon.session ];then
   mv /usr/share/gnome-session/sessions/cinnamon.session /usr/share/gnome-session/sessions/cinnamon.session.bkp
 fi

 if [ -e /usr/share/xsessions/cinnamon.desktop ]; then
  mv /usr/share/xsessions/cinnamon.desktop /usr/share/xsessions/cinnamon.desktop.bkp
 fi

 ##Copiando script personalizado para manejar el fallback y su xsession
 cp "$1" /usr/bin/
 cp "$2" /usr/share/xsessions/

}

override_app_for_cinnamon_in_lxde(){
# Misma observación que la función anterior, en el peor de los casos debería estar en el módulo cinnamon.
# Además panels no es un array. Fernando.
# Corregido :). Atilio
  app="$1"
  override="$2"
  panels=(`find /home/*/.config/ /etc/xdg/ /etc/skel/.config/ -iname "panel" 2>/dev/null`)
  for p in $panels; do
    sed -re "s/$app/$override/g" -i "$p" 2>/dev/null
  done
}

#recive una lista desktop {1.desktop,abc.desktop,1o1o1.desktop}
copy_Specific_Desktop(){
  list_desktop=$2
  src=$1
  dst=$3
  cp -f $src/$lista $dst >/dev/null
}

copiar_desktop(){
# Este script tiene errores, lista no es un array y esta funcionalidad
# debería estar en el módulo freedesktop. Fernando.
# Corregido :). Atilio
 param="$1"
 lista=`(ls "$param" | grep .desktop 2>/dev/null)`
 for app in $lista; do
   app_0=`echo $app | cut -d'.' -f1`
   valor=`ls /var/lib/dpkg/info/ | grep "$app_0.list" | wc -l`
   if [ "$valor" -eq 1 ];then
    cp -f "$param"/$app /usr/share/applications/
   fi
 done
}

task_installed(){
	[ -n "$(tasksel --list-tasks | awk '{print $1,$2}' | grep 'i '$1)" ]
}

exit_if_not_installed_task(){
	task_installed "$1" # Version para lihuen 4
	#is_installed task-lihuen-$1
	if [ $? -ne 0 ]; then
		echo "La tarea $1 no está instalada, ignorando configuraciones relacionadas"
		exit 1
	fi
}


if [ "$(ps -C gconfd-2 | grep gconfd-2)" != "" ]; then
        #Si gconfd-2 este activo hay que matarlo como consecuencia de usar --direct abajo
        killall -9 gconfd-2
fi
#Usamos --direct para poder configurar las cosas sin que gconfd-2 esté activo (por ejemplo
#cuando la máquina esté booteando)
gconftool="dbus-launch gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults "


obsolete(){
	tput smso
	tput setab 7
	tput setaf 1
	printf "LihuenConfig: Módulo $0 obsoleto, se sale con error:"
	tput sgr0
	echo ""
	tput setaf 3
	if [ $# -gt 0 ]; then
		echo " > $*"
	else
		echo " > Este módulo contiene funcionalidad que probablemente ya no sea necesaria"
	fi
	tput op
	exit 1
}

